from Blender import *
import bpy
import random

def_size = 7
def_pos = (0,0)
def_screen = (20,20)
k = 2.0
color_r = 10
color_g = 20
color_b = 14
width = 0
revers = True
max_gener = 5

editmode = Window.EditMode()
if editmode: Window.EditMode( 0 )

def cube( posx , posy , posz , size , gener ):
	size = size / 2
	h = random.randint(0,10-gener)
	coord = [[0,0,0],
					 [posx+size,posy-size,posz+size],
					 [posx+size,posy+size,posz+size],
					 [posx+size,posy+size,posz-size+h],
					 [posx+size,posy-size,posz-size+h],
					 [posx-size,posy-size,posz+size],
					 [posx-size,posy+size,posz+size],
					 [posx-size,posy+size,posz-size+h],
					 [posx-size,posy-size,posz-size+h]]

	faces = [
						[1,2,6,5]
						,[1,2,3,4]
					  ,[6,5,8,7]
						,[3,2,6,7]
					  ,[4,3,7,8]
					  ,[4,1,5,8]
					]
					
	me = bpy.data.meshes.new('SupaCube') 
	
	me.verts.extend( coord )
	me.faces.extend( faces )
	
	me.vertexColors = 1
	
	me.faces[0].col[0].r = 255
	me.faces[0].col[1].g = 255
	me.faces[0].col[2].b = 255
	
	scn = bpy.data.scenes.active
	ob = scn.objects.new( me , 'myObj' )
	if editmode: Window.EditMode(1)	
		
list = []		
		
def Star( gener , posx , posy , posz , size ):
	if (size < 0.2) or (gener > max_gener):
		return
	list.append((gener,posx,posy,posz,size))
	t_size = size / k
	for i in xrange(0,4):
		Star( gener+1 , posx+steps[i][0]*t_size , posy+steps[i][1]*t_size , posz+t_size, t_size)		
		
steps = [[-1,-1],[1,-1],[-1,1],[1,1]]
color = [ 180 , 100 , 50 ]
colors = []
for i in xrange(0,8):
	colors.append(((color[0] + (7-i)*color_r )%255, (color[1] + (7-i)*color_g)%255 , (color[2]+(7-i)*color_b)%255 ) )
		
list = []
list.append((0 , def_pos[0] , def_pos[1] , 0 , def_size))
Star( 0 , def_pos[0] , def_pos[1] , 0 , def_size )

for i in xrange(0,len(list)):
	cube( list[i][1], list[i][2] , list[i][3] , list[i][4] , list[i][0] )



	
	
	
	
	
